brain_two/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path("admin/", admin.site.urls),
    path("todos/", include("todos.urls")),
]

todos/urls.py
from django.urls import path
from todos.views import (
    TodoListView,
    TodoDetailView,
    TodoCreateView,
    TodoUpdateView,
    TodoDeleteView,
    TodoItemCreateView,
    TodoItemUpdateView,
)


urlpatterns = [
    path("", TodoListView.as_view(), name="todo_list_list"),
    path("<int:pk>/", TodoDetailView.as_view(), name="todo_list_detail"),
    path("create/", TodoCreateView.as_view(), name="todo_list_create"),
    path("<int:pk>/edit/", TodoUpdateView.as_view(), name="todo_list_update"),
    path("<int:pk>/delete/", TodoDeleteView.as_view(), name="todo_list_delete"),
    path(
        "items/create/", TodoItemCreateView.as_view(), name="todo_item_create"
    ),
    path(
        "items/<int:pk>/edit/",
        TodoItemUpdateView.as_view(),
        name="todo_item_update",
    ),
]

todos/models.py
from django.db import models

# Create your models here.


class TodoList(models.Model):
    name = models.CharField(max_length=100)
    created_on = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name


class TodoItem(models.Model):
    task = models.CharField(max_length=100)
    due_date = models.DateTimeField(null=True, blank=True)
    is_completed = models.BooleanField(default=False)
    list = models.ForeignKey(
        TodoList, related_name="items", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.task

todos/views.py
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from todos.models import TodoList, TodoItem

# Create your views here.


class TodoListView(ListView):
    model = TodoList
    template_name = "todo_list.html"


class TodoDetailView(DetailView):
    model = TodoList
    template_name = "todo_detail.html"


class TodoCreateView(CreateView):
    model = TodoList
    template_name = "todo_create.html"
    fields = ["name"]

    def form_valid(self, form):
        plan = form.save(commit=True)
        return redirect("todo_list_detail", pk=plan.id)


class TodoUpdateView(UpdateView):
    model = TodoList
    template_name = "todo_update.html"
    fields = ["name"]

    def form_valid(self, form):
        plan = form.save(commit=True)
        return redirect("todo_list_detail", pk=plan.id)


class TodoDeleteView(DeleteView):
    model = TodoList
    template_name = "todo_delete.html"
    success_url = reverse_lazy("todo_list_list")


class TodoItemCreateView(CreateView):
    model = TodoItem
    template_name = "item_create.html"
    fields = ["task", "due_date", "is_completed", "list"]

    def get_success_url(self):
        return reverse_lazy("todo_list_detail", args=[self.object.list.id])


class TodoItemUpdateView(UpdateView):
    model = TodoItem
    template_name = "item_update.html"
    fields = ["task", "due_date", "is_completed", "list"]

    def get_success_url(self):
        return reverse_lazy("todo_list_detail", args=[self.object.list.id])

todos/templates/item_create.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>Create a new item</h1>
        <form method="post">
          {% csrf_token %} {{ form.as_p }}
          <button>Create</button>
        </form>
      </div>
    </main>
  </body>
</html>

todos/templates/item_update.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>Update item</h1>
        <form method="post">
          {% csrf_token %} {{ form.as_p }}
          <button>Update</button>
        </form>
      </div>
    </main>
  </body>
</html>

todos/templates/todo_create.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>Create a new list</h1>
        <form method="post">
          {% csrf_token %} {{ form.as_p }}
          <button>Create</button>
        </form>
      </div>
    </main>
  </body>
</html>

todos/templates/todo_delete.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>Are you sure?</h1>
        <form method="post">
          {% csrf_token %} {{ form.as_p }}
          <button>Delete</button>
        </form>
      </div>
    </main>
  </body>
</html>

todos/templates/todo_detail.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>{{ todolist.name }}</h1>
              <p>
          <a href="{% url 'todo_list_update' todolist.pk %}">Update</a>
        </p>
        <p>
          <a href="{% url 'todo_list_delete' todolist.pk %}">Delete</a>
        </p>
        <h2>Tasks</h2>
            <table>
        <thead>
          <tr>
            <th>Task</th>
            <th>Due date</th>
          </tr>
        </thead>
        <tbody>
          {% for item in todolist.items.all %}
            <tr>
              <td>
                <a href="{% url 'todo_item_update' item.pk %}">
                  {{ item.task }}
                </td>
              </a>
              <td>{{ item.due_date }}</td>
            </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
    </main>
  </body>
</html>

todos/templates/todo_list.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>My Lists</h1>
        <p>
          <a href="{% url 'todo_list_create' %}">Create a new list</a>
          <a href="{% url 'todo_item_create' %}">Create a new item</a>
        </p>
        <table>
          <thead>
            <tr>
              <th>Name</th>
              <th>Number of items</th>
            </tr>
          </thead>
          <tbody>
            {% for item in todolist_list %}
            <tr>
              <td>
                <a href="{% url 'todo_list_detail' item.id %}"
                  >{{ item.name }}</a
                >
              </td>
              <td>{{ item.items.all|length }}</td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
    </main>
  </body>
</html>

todos/templates/todo_update.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <title></title>
  </head>
  <body>
    <main>
      <div>
        <h1>Update list</h1>
        <form method="post">
          {% csrf_token %} {{ form.as_p }}
          <button>Update</button>
        </form>
      </div>
    </main>
  </body>
</html>